__author__ = 'tanshu'
from PyQt5 import uic, QtCore


file = '/home/tanshu/Programming/summer/summer/QtDesignerFiles/ProductGroupDetail.ui'
base, form = uic.loadUiType(file)


class ProductGroupDetail(base, form):
    def __init__(self, router, product_group, parent=None):
        super(ProductGroupDetail, self).__init__()
        self.setupUi(self)
        self.router = router
        self.product_group = product_group
        self.txtName.setText(product_group['Name'])
        self.sbMaxDiscount.setMaximum(100)
        self.sbMaxDiscount.setMinimum(0)
        self.sbMaxDiscount.setValue(product_group['MaxDiscount'] * 100)
        self.txtHeader.setText(product_group['Header'])
        self.chkIsActive.setCheckState(QtCore.Qt.Checked if product_group['IsActive'] else QtCore.Qt.Unchecked)
        self.sbSortOrder.setMinimum(0)
        self.sbSortOrder.setValue(product_group['SortOrder'])
        self.accepted.connect(self.save_product_group)
        self.setAttribute(QtCore.Qt.WA_DeleteOnClose, True)

    def save_product_group(self):
        self.product_group['Name'] = self.txtName.text()
        self.product_group['MaxDiscount'] = self.sbMaxDiscount.value() / 100
        self.product_group['Header'] = self.txtHeader.text()
        self.product_group['IsActive'] = self.chkIsActive.isChecked()
        self.product_group['SortOrder'] = self.sbSortOrder.value()

        self.router.save_product_group(self.product_group)
